
package QRgen;

import com.google.zxing.WriterException;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;

/**
 *
 * @author xfeda002
 */
public class PPAP 
{
    public final QRgen qrCode;
    public final Obrazek logo;
    public final String path;
    public final double scalePercent;

    public PPAP (QRgen qrCode, Obrazek logo, String path, double scalePercent)
    {
       this.qrCode = qrCode;
       this.logo = logo;
       this.path = path;
       this.scalePercent = scalePercent;
    }

    public int scaledSide(int side)
    {
        int newSide = (int)Math.round(side * scalePercent);
        return newSide;
    }

    public BufferedImage getSmolLogo (int x, int y)
    {
        BufferedImage smolLogo = new BufferedImage(x, y, BufferedImage.TYPE_INT_RGB);
        Graphics2D logo2D = smolLogo.createGraphics();
        logo2D.drawImage(logo.loadLogo().getScaledInstance(x, y, BufferedImage.SCALE_SMOOTH), 0, 0, new Color(0,0,0,0), null);
        logo2D.dispose();
        return smolLogo;
    }

    public int startPoint (int side)
    {
        int start = (int)Math.round((side - side * scalePercent) / 2);
        return start;
    }

    public BufferedImage combineImages ()
        throws IOException, WriterException
    {
        BufferedImage qr = qrCode.convertToBufferedImage(qrCode.generateQRcode());
        BufferedImage logo = getSmolLogo(scaledSide(qrCode.width()), scaledSide(qrCode.height()));
        BufferedImage combined = new BufferedImage(qrCode.width(), qrCode.height(), BufferedImage.TYPE_INT_RGB);
        Graphics2D image = combined.createGraphics();
        image.drawImage(qr, 0, 0, null);
        image.drawImage(logo, startPoint(qrCode.width()), startPoint(qrCode.height()), null);
        image.dispose();
        return combined;
    }
    public void saveQRCode(BufferedImage image)
        throws IOException
    {
        File outputfile = new File(path);
        ImageIO.write(image, "png", outputfile);
    }
}
